let $containerEvening, $containerMorning, $containerAfternoon;
let today;
let thisMonth;
let fullDate;

const weekday = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"];
const month = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sept", "Okt", "Nov", "Dec"];

const initCalendar = () => {
    today = new Date().getFullYear() +"-" +  ("0" + (new Date().getMonth() + 1)).slice(-2) + "-" +("0" + new Date().getDate()).slice(-2)
    thisMonth = new Date().getMonth() +  1;
    console.log(thisMonth);


    const $date = document.querySelector(".js-date");
    $date.innerHTML = month[new Date().getMonth()] + " " + new Date().getDate() + "th";
    $date.innerHTML += " <span></span>"

    $date.getElementsByTagName("span")[0].innerHTML = weekday[new Date().getDay()];
    
    $containerMorning = document.querySelector(".js-schedule-morning");
    $containerAfternoon=  document.querySelector(".js-schedule-afternoon");
    $containerEvening= document.querySelector(".js-schedule-evening");

    socket.emit("getTakenDays", thisMonth)
    socket.emit("getLateDays", thisMonth)
    socket.emit("getNotTakenDays", thisMonth)
    socket.emit("getScheduleToday")
    socket.emit("checkMedicationTaken", today)
    socket.emit("checkMedicationNotTaken", today)
    socket.emit("checkMedicationtTakenLate", today)

    socket.on('schedule', scheduleData => {

        schedules = JSON.parse(scheduleData)

        if (schedules.length == 0){
            document.querySelector(".js-message-no-schedule").classList.remove('is-hidden');
        }else {
            document.querySelector(".js-message-no-schedule").classList.add('is-hidden');
        }

        let allfilterScheduleArray = []
        
        schedules.forEach((element) => {
            let filterScheduleArray = []   
            let scheduleExists = false 
            let filterSchedule = schedules.filter(e => e.TimeDue == element["TimeDue"]);
            if(filterSchedule.length > 1) {
                if (!filterScheduleArray.includes(filterSchedule[0])){
                    filterSchedule.forEach((element) => {
                        filterScheduleArray.push(element);
                    });
                    if (allfilterScheduleArray.length == 0){
                        allfilterScheduleArray.push(filterScheduleArray)
                    }else {
                        allfilterScheduleArray.forEach((element) => {
                            if (element.includes(filterScheduleArray[0])){
                                scheduleExists = true;
                            }
                        })

                        if (scheduleExists == false){
                            allfilterScheduleArray.push(filterScheduleArray)
                        }
                    }
                }
            } 

            if(filterSchedule.length == 1){
                const hour = element["TimeDue"].split(":")[0];
                if (parseInt(hour) < 12 && parseInt(hour) > 3 ){
                    console.log("Morning");
                    document.querySelector(".js-header-morning").classList.remove("is-hidden");
                    showSchedule($containerMorning, element);
                
                } else if(parseInt(hour) >= 12 && parseInt(hour) < 18 ){
                    console.log("Afternoon");
                    document.querySelector(".js-header-afternoon").classList.remove("is-hidden");
                    showSchedule($containerAfternoon, element);
                
                }else if(parseInt(hour) >= 18 || parseInt(hour) <= 3){
                    console.log("Evening");
                    document.querySelector(".js-header-evening").classList.remove("is-hidden");
                    showSchedule($containerEvening, element);
                }
            }

            // const $scheduleDivs = document.querySelectorAll(".js-schedule-click");
            // $scheduleDivs.forEach((element) => {
            //     element.addEventListener("click", clickHandlerSchedule)
            // });
        });
       
        if (allfilterScheduleArray.length != 0){
            allfilterScheduleArray.forEach((element) => {
                const hour = element[0]["TimeDue"].split(":")[0];
                if (parseInt(hour) < 12 && parseInt(hour) > 3 ){
                    document.querySelector(".js-header-morning").classList.remove("is-hidden");
                    showGroupSchedule($containerMorning, element)
                
                } else if(parseInt(hour) >= 12 && parseInt(hour) < 18 ){
                    document.querySelector(".js-header-afternoon").classList.remove("is-hidden");
                    showGroupSchedule($containerAfternoon, element)

                }else if(parseInt(hour) >= 18 || parseInt(hour) <= 3){
                    document.querySelector(".js-header-evening").classList.remove("is-hidden");
                    showGroupSchedule($containerEvening, element)
                }
            }); 
        }
    });

    socket.on('medicationStatusTaken', showMedicationStatus)
    socket.on('medicationStatusNotTaken', showMedicationStatus)
    socket.on('medicationStatusNotTaken', showMedicationStatus)
    socket.on('takenDays', showTakenDays)
    socket.on('lateDays', showLateDays)
    socket.on('notTakenDays', showNotTakenDays)
}

const showSchedule = ($container, element) => {
    const $schedule = document.querySelector(".js-schedule");

    const schedule = $schedule.cloneNode(true);
    schedule.classList.remove("is-hidden")
    schedule.querySelector(".js-medication").classList.remove("is-hidden");

    schedule.querySelector(".js-name").innerHTML = element["Name"];
    if (element["Frequancy"] ==  1) {
        schedule.querySelector(".js-quantity").innerHTML = "1 pill"
    }else {
        schedule.querySelector(".js-quantity").innerHTML = element["Frequancy"] + " pills"
    }

    const timeArray =  element["TimeDue"].split(":");
    const time = ("0" + timeArray[0]).slice(-2) + ":" +  timeArray[1]
    schedule.querySelector(".js-time").innerHTML = time + "h"

    schedule.dataset.name = element["Name"];
    schedule.dataset.time = time;

    $container.appendChild(schedule);
}

const showGroupSchedule = ($container, elements) => {
    const $schedule = document.querySelector(".js-schedule");

    const schedule = $schedule.cloneNode(true);
    schedule.classList.remove("is-hidden")

    const timeArray =  elements[0]["TimeDue"].split(":");
    const time = ("0" + timeArray[0]).slice(-2) + ":" +  timeArray[1]
    schedule.querySelector(".js-time").innerHTML = time + "h"
    const $scheduleGroup = schedule.querySelector(".js-schedule-group");

    schedule.dataset.name = elements[0]["Name"];
    schedule.dataset.time = time;

    $container.appendChild(schedule);

    elements.forEach((element) => {
        const $medication = $scheduleGroup.querySelector(".js-medication")
        const medication = $medication.cloneNode(true);
        medication.classList.remove("is-hidden")
        medication.querySelector(".js-name").innerHTML = element["Name"];
        if (element["Frequancy"] ==  1) {
            medication.querySelector(".js-quantity").innerHTML = "1 pill"
        }else {
            medication.querySelector(".js-quantity").innerHTML = element["Frequancy"] + " pills"
        }

        $scheduleGroup.appendChild(medication);

    });
}

const DateClickedHandler  = e => {
    fullDate = new Date(e.currentTarget.dataset.calendarDate);
    const date = fullDate.getFullYear() +"-" +  ("0" + (fullDate.getMonth() + 1)).slice(-2) + "-" +("0" + fullDate.getDate()).slice(-2)
    

    const $date = document.querySelector(".js-date");
    $date.innerHTML = month[fullDate.getMonth()] + " " + fullDate.getDate() + "th";
    $date.innerHTML += " <span></span>"

    $date.getElementsByTagName("span")[0].innerHTML = weekday[fullDate.getDay()];

    const $hiddenSchedule = document.querySelector(".js-schedule");
    $containerMorning.innerHTML = "";
    $containerMorning.appendChild($hiddenSchedule);
    document.querySelector(".js-header-morning").classList.add("is-hidden");

    $containerAfternoon.innerHTML = "";
    document.querySelector(".js-header-afternoon").classList.add("is-hidden");

    $containerEvening.innerHTML = "";
    document.querySelector(".js-header-evening").classList.add("is-hidden");

    socket.emit("getScheduleDay", date)
    socket.emit("checkMedicationTaken", date)
    socket.emit("checkMedicationNotTaken", date)

    if (window.innerWidth <= 1115){
        var queryString = "?date=" + date;
        window.location = "selected-day.html" + queryString;
    }

}

// const clickHandlerSchedule = e => {
//     const name = e.currentTarget.dataset.name;
//     const time =  e.currentTarget.dataset.time;
//     const date = new Date().toLocaleDateString();

//     var queryString = "?name=" + name + "&time=" + time + "&date=" + date;
//     window.location = "edit-dose-schedule.html" + queryString;
// }

const showMedicationStatus = medicationStatus => {
    medication  = JSON.parse(medicationStatus)
    let indexNotTaken = 0;
    let indexTaken = 0;
    let indexTakenTooLate = 0;

    medication.forEach((element) => {
        const timeArray =  element["TimeDue"].split(":");
        const time = ("0" + timeArray[0]).slice(-2) + ":" +  timeArray[1]

        const $medicationTaken = document.querySelectorAll(`[data-name= ${element["Name"]} ][data-time = "${time}"]`)[0];
        
        if ($medicationTaken) {
            const $statusDiv = $medicationTaken.querySelector('.js-status')
            if (element["IsTaken"] == "Taken"){
                $statusDiv.innerHTML= showSvg("Taken");
                $statusDiv.classList.add("is-taken");
                indexTaken ++;
            }else if (element["IsTaken"] == "Not taken"){
                $statusDiv.innerHTML= showSvg("Not taken");
                $statusDiv.classList.add("is-not-taken");
                indexNotTaken ++;
            }else if (element["IsTaken"] == "Late"){
                $statusDiv.innerHTML= showSvg("Late");
                $statusDiv.classList.add("is-taken-late");
                indexTakenTooLate ++;
            }
        }
    });


    if (indexNotTaken != 0) {
        const $container = document.querySelector(".js-ctnr-message");
        $container.classList.remove("is-hidden")
        if (indexNotTaken == 1) {
            $container.querySelector(".js-message").innerHTML = indexNotTaken + " dose"

        } else {
            $container.querySelector(".js-message").innerHTML = indexNotTaken + " doses"
        }
    } else {
        const $container = document.querySelector(".js-ctnr-message");
        $container.classList.add("is-hidden")
    }
}

const showSvg = status => {
    if(status == "Taken" || status == "Late"){
        return '<svg xmlns="http://www.w3.org/2000/svg" width="13.402" height="9.828" viewBox="0 0 13.402 9.828"><path d="M4.822,9.828a1.049,1.049,0,0,1-.752-.317L.311,5.68a1.1,1.1,0,0,1,0-1.532,1.049,1.049,0,0,1,1.5,0L4.822,7.212l6.766-6.9a1.049,1.049,0,0,1,1.5,0,1.1,1.1,0,0,1,0,1.532L5.573,9.511a1.05,1.05,0,0,1-.752.317" fill="#fff" /></svg>'

    }else if(status == "Not taken"){
        return '<svg xmlns="http://www.w3.org/2000/svg" width="13.402" height="9.828" viewBox="0 0 13.402 9.828"><path d="M4.822,9.828a1.049,1.049,0,0,1-.752-.317L.311,5.68a1.1,1.1,0,0,1,0-1.532,1.049,1.049,0,0,1,1.5,0L4.822,7.212l6.766-6.9a1.049,1.049,0,0,1,1.5,0,1.1,1.1,0,0,1,0,1.532L5.573,9.511a1.05,1.05,0,0,1-.752.317" fill="#fff" /></svg>'
    }
}


const showTakenDays = result => {
    const takenDays = JSON.parse(result)
    takenDays.forEach(element => {
        const date = element["Date(DateTime)"].split(" ")[0];
        const day = document.querySelector(`[data-date = '${date}']`);
        day.classList.add("c-cal__date--taken");
    })
    
}

const showLateDays = result => {
    const lateDays = JSON.parse(result)
    lateDays.forEach(element => {
        const date = element["Date(DateTime)"].split(" ")[0];
        const day = document.querySelector(`[data-date = '${date}']`);
        day.classList.add("c-cal__date--taken");
    })
}

const showNotTakenDays = result => {
    const notTakenDays = JSON.parse(result)
    notTakenDays.forEach(element => {
        const date = element["Date(DateTime)"].split(" ")[0];
        const day = document.querySelector(`[data-date = '${date}']`);
        day.classList.add("c-cal__date--not-taken");
    })
}



document.addEventListener('DOMContentLoaded', () => {
    console.info('DOM loaded');
    initCalendar();
});

window.addEventListener('load', function() {
    vanillaCalendar.init();
  })