let $form, $daySelectInputs, day, $dayError, $dayGroup, $weekdays, selectedWeekdays,
$buttonAddMedication, $inputMedication, $removeMedicatonButton, selectedMedication,
$checkbox;

const getFormElements = () => {
  $form  = document.querySelector(".c-form--schedule");
  $form.noValidate=true;
  $form.addEventListener('submit', onFormSubmit);

  $daySelectInputs = document.querySelectorAll(".c-form__input--select-period");
  $dayError = document.querySelector(".c-form__error--day");
  $dayGroup = document.querySelector(".c-form__days-group");
  $weekdays = document.querySelectorAll(".c-form__input--select--small");


  $daySelectInputs.forEach((element) => {
    element.addEventListener('click', onClickHandelerDay);
  });

  $weekdays.forEach((element) => {
    element.addEventListener('click', onClickHandelerWeekday);
  });

  selectedWeekdays = [];
  selectedMedication = [];

  $buttonAddMedication = document.querySelector(".anchor--add");
  $inputMedication = document.querySelector(".c-form__input-medication");
  $buttonAddMedication.addEventListener('click', onHandlerClickAdd);

  $form.addEventListener('submit', onFormSubmit);
  $checkbox = document.querySelector(".checkbox-time");
  $checkbox.addEventListener('change', onHandlerCheckboxChange);



  document.getElementsByName('quantity')[0].addEventListener('input', onNameChange);
  document.getElementsByName('medication')[0].addEventListener('input', onNameChange);
  document.getElementsByName('start-date')[0].addEventListener('input', onNameChange);
  document.getElementsByName('end-date')[0].addEventListener('input', onNameChange);
  document.getElementsByName('time')[0].addEventListener('input', onNameChange);

  document.getElementsByName('start-date')[0].addEventListener('blur', onNameChange);
  document.getElementsByName('quantity')[0].addEventListener('blur', onNameChange);
  document.getElementsByName('medication')[0].addEventListener('blur', onNameChange);
  document.getElementsByName('end-date')[0].addEventListener('blur', onNameChange);
  document.getElementsByName('time')[0].addEventListener('blur', onNameChange);

  socket.emit("getMedicationsInContainer");
  socket.on('medicationsInContainer', fillUpSelect);

  const todayDate = new Date().getFullYear() +"-" +  ("0" + (new Date().getMonth() + 1)).slice(-2) + "-" +("0" + new Date().getDate()).slice(-2)

  document.getElementsByName('start-date')[0].min = todayDate;


}

const fillUpSelect = data => {
  const $select = document.querySelector(".js-select");
  data.forEach((element) => {
    const opt = document.createElement('option');
    opt.innerHTML = element["Name"];
    opt.value = element["Name"];
    $select.appendChild(opt);
  });
}

const onFormSubmit = event => {
  event.preventDefault();
  if(!$form.checkValidity()){
    checkName(document.getElementById('quantity'));
    checkName(document.getElementById('start-date'));
    checkName(document.getElementById('end-date'));
    checkName(document.getElementById('medication'));

    let $medications = document.getElementsByName('medication');
    let $quantities = document.getElementsByName('quantity');
    let $times = document.getElementsByName('time');

    $medications.forEach((element) => {
      checkName(element)
    });

    $times.forEach((element) => {
      checkName(element)
    });

    $quantities.forEach((element) => {
      checkName(element)
      if (element.value > 5) {
        element.parentNode.querySelector('.c-form__error').innerHTML='Value must be less than or equal 5';
      }
    });

    if (document.getElementById('end-date').value < document.getElementById('start-date')) {
      document.getElementById('end-date').parentNode.querySelector('.c-form__error').innerHTML='End date needs to be bigger than start date';
    }

    if (day == null) {
      $dayError.innerHTML='*Please make a selection';
    }else if(selectedWeekdays.length == 0) {
      $dayError.innerHTML='*Please select a day of the week';
    }

  }else{
    let startDate = document.getElementById('start-date').value;
    let endDate = document.getElementById('end-date').value;
    let $medications = document.getElementsByName('medication');
    let $quantities = document.getElementsByName('quantity');

    let $time = document.getElementsByName('time')[0].value;
    let $times = document.querySelectorAll('.js-time-input');

    if ($checkbox.checked == true) {
      for (let i = 0; i < $medications.length; i++) {
        const dict = { medication:$medications[i].value, quantity:$quantities[i].value, time:$time};
        selectedMedication.push(dict)
      }
    }else {
      for (let i = 0; i < $medications.length; i++) {
        const dict = { medication:$medications[i].value, quantity:$quantities[i].value, time:$times[i+2].value};
        selectedMedication.push(dict)
      }
    }

    if (day == null) {
      $dayError.innerHTML='*Please make a selection';
    }else if(selectedWeekdays.length == 0){
      $dayError.innerHTML='*Please select a day of the week';
    }else {

      if(event.currentTarget.querySelector(".js-submit").dataset.btn == "add") {
        const data = {StartDate: startDate, EndDate: endDate, DaysOfTheWeek:selectedWeekdays, Medications: selectedMedication}
        console.log("add")
        socket.emit("addDoseSchedule", data);
        window.location = "calendar.html";
      }else {
        console.log("update")
        socket.emit("updateDoseSchedule", data);
      }
    }

  }
};

const onNameChange = e =>{
  let $field = e.currentTarget;
  if(e.type==='blur'){
    checkName($field)
  }else if(e.type==='input'){
    if($field.validity.valid){
      if ($field.name == "medication") {

        let $inputTimes = document.querySelectorAll('.js-med-time');
        let $medications = document.getElementsByName('medication');

        if ($inputTimes.length != $medications.length) {
          addOneMedicationTime()
        }

        $inputTimes = document.querySelectorAll(".js-med-time");
        $inputTimes[$field.parentNode.parentNode.parentNode.dataset.number - 1].querySelector('.name-medication').innerHTML = $field.value;

        $field.parentNode.parentNode.querySelector('.name-medication').innerHTML = $field.value;
        $field.parentNode.parentNode.querySelector('.c-form__error').innerHTML = '';
      }else if ($field.name == "start-date"){
        document.getElementsByName('end-date')[0].min = $field.value;
        $field.parentNode.querySelector('.c-form__error').innerHTML='';
      } else {
          $field.parentNode.querySelector('.c-form__error').innerHTML='';
      }
    }
  }
}

const checkName = $field => {
  if ($field.name == "medication") {
    $field.parentNode.parentNode.querySelector('.c-form__error').innerHTML = valueMissing($field);
  }else {
    $field.parentNode.querySelector('.c-form__error').innerHTML = valueMissing($field);
  }
}

const valueMissing = $field => {
  const fieldName = $field.name;
  if($field.validity.valueMissing){
    if (fieldName == "medication") {
      return "*Please select a medication";
    }
    return `*Please fill in a valid ${fieldName.replace(/-/g, " ")}`;
  }
  return '';
}

const onClickHandelerDay = e => {
  $weekdays.forEach((element) => {
    element.classList.remove('is-selected');
  });
  $daySelectInputs.forEach((element) => {
    element.classList.remove('is-selected');
  });
  e.currentTarget.classList.add('is-selected');
  day = e.currentTarget.dataset.day;
  $dayError.innerHTML= '';

  if (day == "select days") {
    $dayGroup.classList.remove("is-hidden");
    selectedWeekdays = [];
  }else {
    $dayGroup.classList.add("is-hidden");
    selectedWeekdays = [];
    selectedWeekdays = ["everyday"]
  }
}

const onClickHandelerWeekday = e => {
  e.currentTarget.classList.toggle('is-selected');
  $dayError.innerHTML= '';

  if (selectedWeekdays.includes(e.currentTarget.dataset.day)) {
    var index = selectedWeekdays.indexOf(e.currentTarget.dataset.day);
    selectedWeekdays.splice(index, 1);
  }else {
    selectedWeekdays.push(e.currentTarget.dataset.day)
  }
}

const onHandlerClickAdd = e => {
  e.preventDefault();

  const inputMed = $inputMedication.cloneNode(true);


  inputMed.querySelector('.name-medication').innerHTML = '';
  inputMed.querySelector('.icon__remove').classList.remove("is-hidden")
  let $meds = document.getElementsByName('medication');

  inputMed.dataset.number = $meds.length + 1;
  document.querySelector('.c-form-med-group').appendChild(inputMed);

  $removeMedicatonButton = document.querySelectorAll(".icon__remove");
  $removeMedicatonButton.forEach((element) => {
    element.addEventListener('click', onClickHandelerRemove);
  });

  let $medications = document.getElementsByName('medication');
  let $quantities = document.getElementsByName('quantity');

  $medications.forEach((element) => {
    element.addEventListener('input', onNameChange);
    element.addEventListener('blur', onNameChange);
  });

  $quantities.forEach((element) => {
    element.addEventListener('input', onNameChange);
    element.addEventListener('blur', onNameChange);
  });


  let $timeInputs = document.getElementsByName('time');
  $timeInputs.forEach((element) => {
    element.addEventListener('input', onNameChange);
    element.addEventListener('blur', onNameChange);
  });


  addOneMedicationTime();
}

const onClickHandelerRemove = e => {
    e.preventDefault();
    document.querySelector('.c-form-med-group').removeChild(e.currentTarget.parentNode.parentNode.parentNode);
    removeOneMedicationTime();
}

const onHandlerCheckboxChange = e => {
    if (e.currentTarget.checked == true){
      document.querySelector(".js-time-input").classList.remove("is-hidden");
      document.querySelector(".js-time-input").required = true;
      document.querySelector(".js-time-input").parentNode.querySelector(".c-form__error").innerHTML = "";

      let $inputTimes = document.querySelectorAll('.js-med-time');
      $inputTimes.forEach((element) => {
        element.classList.add("is-hidden");
        element.required = false;
      });

    } else {
      document.querySelector(".js-time-input").classList.add("is-hidden");
      document.querySelector(".js-time-input").required = false;
      document.querySelector(".js-time-input").parentNode.querySelector(".c-form__error").innerHTML = "";

      let $inputTimes = document.querySelectorAll('.js-med-time');
      let $medications = document.getElementsByName('medication');

      $inputTimes.forEach((element) => {
        element.classList.remove("is-hidden");
        element.required = true;
      });

      if ($inputTimes.length != $medications.length) {
        addOneMedicationTime()
      }
    }
}

const addOneMedicationTime = () => {
  const $inputTime = document.querySelectorAll(".js-med-time")
  const $inputTimeGroup = document.querySelector(".js-time")
  const inputTime = $inputTimeGroup.cloneNode(true);
  inputTime.classList.add("js-med-time");
  inputTime.classList.remove("js-time");
  document.querySelector('.js-time-group').appendChild(inputTime);

  if ($checkbox.checked != true){
    inputTime.classList.remove("is-hidden");
  }
}

const removeOneMedicationTime = () => {
  const $inputTime = document.querySelectorAll(".js-med-time")
  document.querySelector('.js-time-group').removeChild($inputTime[$inputTime.length-1]);
}


document.addEventListener('DOMContentLoaded', () => {
    console.info('DOM loaded');
    getFormElements();
});
