let data;
const initMedication = () => {

    socket.emit("getMedications");
    socket.on('medications', showMedications);

    socket.on('removedMedication', () => {
        document.querySelector(".js-pop-up-medication").classList.add("is-hidden");
        document.querySelector(".js-container-medication").classList.add("is-hidden");
        document.querySelector(".l-header").style.pointerEvents = "initial";
        socket.emit("getMedications");
    });

}

const showMedications = data => {

    const $container = document.querySelector('.js-med-container');
    const $hiddenArticle = document.querySelector('.is-hidden');
    $container.innerHTML = "";
    $container.appendChild($hiddenArticle);

    const $article = document.querySelector('.js-medication');

    if (data != null){
        data.forEach((element) => {
            const article = $article.cloneNode(true);
            $article.classList.remove("is-hidden")
            $article.dataset.name = element["Name"];
            $article.dataset.ctnr = element["container"];
            $article.querySelector(".js-name").innerHTML = element["Name"];
            $article.querySelector(".js-description").innerHTML = element["Description"];
    
            if (element["container"] != null) {
                $article.querySelector(".js-container").innerHTML = element["container"];
            }else {
                $article.querySelector(".js-container").innerHTML = "No container filled"
            }
            $container.appendChild(article);
        });
    }

    let $buttonsRemove = document.querySelectorAll(".js-btn-remove");

    $buttonsRemove.forEach((element) => {
        element.addEventListener("click", clickHandlerRemove)
    });

    
    const $buttonsEdit = document.querySelectorAll(".js-btn-edit");
    $buttonsEdit.forEach((element) => {
        element.addEventListener("click", clickHandlerEdit)
    });
}

const clickHandlerRemove = e => {
    e.preventDefault();
    console.log('click')
    const name = e.currentTarget.parentNode.parentNode.parentNode.dataset.name;
    const ctnr = e.currentTarget.parentNode.parentNode.parentNode.dataset.ctnr;
    data = {Name: name, Container: ctnr};

    document.querySelector(".js-pop-up-medication").classList.remove("is-hidden");
    document.querySelector(".js-container-medication").classList.remove("is-hidden");
    document.querySelector(".l-header").style.pointerEvents = "none";

    document.querySelector(".js-cancel").addEventListener("click", clickHandlerCancel)
    document.querySelector(".js-go").addEventListener("click", clickHandlerDelete)

    
}

const clickHandlerDelete = () => {
    socket.emit("removeMedication", data);
}

const clickHandlerCancel = () => {
    document.querySelector(".js-pop-up-medication").classList.add("is-hidden");
    document.querySelector(".js-container-medication").classList.add("is-hidden");
    document.querySelector(".l-header").style.pointerEvents = "initial";
}

const clickHandlerEdit = e => {
    e.preventDefault();
    const name = e.currentTarget.parentNode.parentNode.parentNode.dataset.name;
    const ctnr = e.currentTarget.parentNode.parentNode.parentNode.dataset.ctnr;

    var queryString = "?name=" + name + "&ctnr=" + ctnr;
    window.location = "edit-medication.html" + queryString;
}

document.addEventListener('DOMContentLoaded', () => {
    console.info('DOM loaded');
    initMedication();
});