let $form, $popUp, $popUpContainer, $medication, $nameContainer, $button;

const getFormElements = () => {
  $form  = document.querySelector(".c-form--medication");
  $popUp  = document.querySelector(".c-pop-up__medication");
  $popUpContainer  = document.querySelector(".l-pop-up__container");
  $nameContainer  = document.querySelector(".js-name-container");
  $medication  = document.querySelector(".js-name-medication");
  $button  = document.querySelector(".c-pop-up__button");
  $popUp.classList.add("is-hidden");
  $popUpContainer.classList.add("is-hidden");
  $form.noValidate=true;

  $form.addEventListener('submit', onFormSubmit);

  
  $button.addEventListener('click', onHandlerButtonClick);


  document.getElementsByName('name')[0].addEventListener('input', onNameChange);
  document.getElementsByName('name')[0].addEventListener('blur', onNameChange);

  socket.emit("getContainers")

  socket.on('containers', fillUpSelect)
}

const fillUpSelect = data => {
  const $select = document.querySelector(".js-select");
  data.forEach((element) => {
    const opt = document.createElement('option');
    opt.innerHTML = element["Name"];
    opt.value = element["Name"];
    $select.appendChild(opt);
  });
}

const onFormSubmit = event => {
  event.preventDefault();
  if(!$form.checkValidity()){
    checkName(document.getElementById('name'));
  }else{
    let name = document.getElementById('name').value;
    let description = document.getElementById('information').value;
    let container = document.getElementById('container').value;

    if (container != "" && container != "none") {
      $popUp.classList.remove("is-hidden");
      $popUpContainer.classList.remove("is-hidden");
      $nameContainer.innerHTML = container;
      $medication.innerHTML = name;
    }else {
      window.location = "medications.html"
    }


    if (container == "Fill no container" || container == ""){
      container = "none";
    }

    if(event.currentTarget.querySelector(".js-submit").dataset.btn == "add") {
      const data = {Name: name, Description: description, Container: container};
      console.log("add")
      socket.emit("addMedication", data);
    }else {
      console.log("update")
      const data = {MedicationId: med[0]["MedicationId"], Name: name, Description: description, Container: container};
      socket.emit("updateMedication", data);
    }
  }
};

const onNameChange = e =>{
  let $field = e.currentTarget;
  if(e.type==='blur'){
    checkName($field)
  }else if(e.type==='input'){
    if($field.validity.valid){
      $field.parentNode.querySelector('.c-form__error').innerHTML='';
    }
  }
}

const checkName = $field => {
  $field.parentNode.querySelector('.c-form__error').innerHTML = valueMissing($field);
}

const valueMissing = $field => {
  const fieldName = $field.name;
  if($field.validity.valueMissing){
    return `*Please fill in a valid ${fieldName.replace(/-/g, " ")}`;
  }
  return '';
}

const onHandlerButtonClick = () => {
  window.location.href = "medications.html";
}

document.addEventListener('DOMContentLoaded', () => {
    console.info('DOM loaded');
    getFormElements();
});
