let patient

const initPatient = () => {

    socket.emit("checkPatientExists")

    socket.on('Patient', patientData => {

        patient = JSON.parse(patientData)
        socket.emit("getPatientInformation", patient[0]["PatientId"])


        if (patient != null) {
            $names = document.querySelectorAll(".c-patient__name")
            $names.forEach((element) => {
                element.innerHTML = patient[0]["FirstName"] + " " + patient[0]["LastName"]
            });
            
            $birthdays = document.querySelectorAll(".c-patient__date-of-birth")
            $birthdays.forEach((element) => {
                element.innerHTML = patient[0]["DateOfBirth"];
            });
           
            document.querySelector(".c-patient__info").innerHTML = patient[0]["Information"]
        }
    });


    socket.on('patientInformation', patientInformation => {
        const patientinfo = JSON.parse(patientInformation);
        if (patientinfo != null) {
            document.querySelector(".js-start-date").innerHTML = patientinfo[0]["DateTime"].split(" ")[0]
        }

        let taken = 0;
        let late = 0;
        let notTaken = 0;

        patientinfo.forEach(element => {
            if (element["IsTaken"] == "Taken") {
                taken++
            }else if (element["IsTaken"] == "Late") {
                late++
                
            }else if (element["IsTaken"] == "Not taken") { 
                notTaken++
            }
        })

        document.querySelector(".js-taken").innerHTML = taken;
        document.querySelector(".js-late").innerHTML = late;
        document.querySelector(".js-not-taken").innerHTML = notTaken;

    });
    
    document.querySelector(".js-btn-remove").addEventListener("click", clickHandlerRemove)
    document.querySelector(".js-btn-edit").addEventListener("click", clickHandlerEdit)
}

const clickHandlerRemove = e => {
    e.preventDefault();

    document.querySelector(".js-pop-up-medication").classList.remove("is-hidden");
    document.querySelector(".js-container-medication").classList.remove("is-hidden");
    document.querySelector(".l-header").style.pointerEvents = "none";

    document.querySelector(".js-cancel").addEventListener("click", clickHandlerCancel)
    document.querySelector(".js-go").addEventListener("click", clickHandlerDelete)

}

const clickHandlerDelete = () => {
    socket.emit("removePatient", patient[0]["PatientId"]);
    window.location = "index.html";
}

const clickHandlerCancel = () => {
    document.querySelector(".js-pop-up-medication").classList.add("is-hidden");
    document.querySelector(".js-container-medication").classList.add("is-hidden");
    document.querySelector(".l-header").style.pointerEvents = "initial";
}


const clickHandlerEdit = e => {
    e.preventDefault();
    console.log("edit");
    window.location = "edit-patient.html";
}

document.addEventListener('DOMContentLoaded', () => {
    console.info('DOM loaded');
    initPatient();
});