let $form, $genderSelectInputs, gender, $genderError;

const getFormElements = () => {
  $genderSelectInputs = document.querySelectorAll(".c-form__input--select");
  $genderError = document.querySelector(".c-form__error--gender");
  $form  = document.querySelector(".c-form--patient");
  $form.noValidate=true;
  $form.addEventListener('submit', onFormSubmit);
  $genderSelectInputs.forEach((element) => {
    element.addEventListener('click', onClickHandelerGender);
  });

  document.getElementsByName('first-name')[0].addEventListener('input', onNameChange);
  document.getElementsByName('last-name')[0].addEventListener('input', onNameChange);
  document.getElementsByName('date-of-birth')[0].addEventListener('input', onNameChange);

  document.getElementsByName('first-name')[0].addEventListener('blur', onNameChange);
  document.getElementsByName('last-name')[0].addEventListener('blur', onNameChange);
  document.getElementsByName('date-of-birth')[0].addEventListener('blur', onNameChange);
}

const onFormSubmit = event => {
  event.preventDefault();
  if(!$form.checkValidity()){
    checkName(document.getElementById('first-name'));
    checkName(document.getElementById('last-name'));
    checkName(document.getElementById('date-of-birth'));
    if (gender == null) {
      $genderError.innerHTML='*Please select a gender';
    }
  }else{
    let firstName = document.getElementById('first-name').value;
    let lastName = document.getElementById('last-name').value;
    let dateOfBirth = document.getElementById('date-of-birth').value;
    let information = document.getElementById('information').value;
    if (gender == null) {
      $genderError.innerHTML='*Please select a gender';
    }else {
      const data = {Gender: gender, FirstName: firstName, LastName: lastName, DateOfBirth: dateOfBirth, Info: information}
      if(event.currentTarget.querySelector(".js-submit").dataset.btn == "add") {
        console.log("add")
        socket.emit("AddPatient", data)
      }else {
        const data = {PatientId: patient[0]["PatientId"], Gender: gender, FirstName: firstName, LastName: lastName, DateOfBirth: dateOfBirth, Info: information}
        console.log("update")
        socket.emit("UpdatePatient", data)
      }
      console.log(data);
    }
  }
};

const onNameChange = e =>{
  let $field = e.currentTarget;
  if(e.type==='blur'){
    checkName($field)
  }else if(e.type==='input'){
    if($field.validity.valid){
      $field.parentNode.querySelector('.c-form__error').innerHTML='';
    }
  }
}

const checkName = $field => {
  $field.parentNode.querySelector('.c-form__error').innerHTML = valueMissing($field);
}

const valueMissing = $field => {
  const fieldName = $field.name;
  if($field.validity.valueMissing){
    return `*Please fill in a valid ${fieldName.replace(/-/g, " ")}`;
  }
  return '';
}

const onClickHandelerGender = e => {
  $genderSelectInputs.forEach((element) => {
    element.classList.remove('is-selected');
  });
  e.currentTarget.classList.add('is-selected');
  gender = e.currentTarget.dataset.gender;
  $genderError.innerHTML= '';
}

const callbackShowPatientInfo = () => {
  window.location = "patient-information.html";
}

document.addEventListener('DOMContentLoaded', () => {
    console.info('DOM loaded');
    getFormElements();

    socket.on("AddedPatient", callbackShowPatientInfo)
});
