let $containerEvening, $containerMorning, $containerAfternoon;
let fullDate;


const weekday = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"];
const month = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sept", "Okt", "Nov", "Dec"];

const initSelectedDay = () => {

    let queryString = decodeURIComponent(window.location.search);
    queryString = queryString.substring(1);
    const queries = queryString.split("&");
    for (let i = 0; i < queries.length; i++)
    {
        const value =  queries[i].split("=");
        fullDate = value[1]
    }
    
    fullDate = new Date(fullDate);
    const date = fullDate.getFullYear() +"-" +  ("0" + (fullDate.getMonth() + 1)).slice(-2) + "-" +("0" + fullDate.getDate()).slice(-2)

    const $date = document.querySelector(".js-date");
    $date.innerHTML = month[fullDate.getMonth()] + " " + fullDate.getDate() + "th";
    $date.innerHTML += " <span></span>"

    $date.getElementsByTagName("span")[0].innerHTML = weekday[fullDate.getDay()];


    document.querySelector(".js-next-day").addEventListener("click", clickHandlerNextDay);
    
    $containerMorning = document.querySelector(".js-schedule-morning");
    $containerAfternoon=  document.querySelector(".js-schedule-afternoon");
    $containerEvening= document.querySelector(".js-schedule-evening");

    socket.emit("getScheduleDay", date )
    socket.emit("checkMedicationTaken", date)
    socket.emit("checkMedicationNotTaken",  date)
    socket.emit("checkMedicationtTakenLate",  date)

    socket.on('schedule', scheduleData => {

        schedules = JSON.parse(scheduleData)

        if (schedules.length == 0){
            document.querySelector(".js-message-no-schedule").classList.remove('is-hidden');
        }else {
            document.querySelector(".js-message-no-schedule").classList.add('is-hidden');
        }

        let allfilterScheduleArray = []
        
        schedules.forEach((element) => {
            let filterScheduleArray = []   
            let scheduleExists = false 
            let filterSchedule = schedules.filter(e => e.TimeDue == element["TimeDue"]);
            if(filterSchedule.length > 1) {
                if (!filterScheduleArray.includes(filterSchedule[0])){
                    filterSchedule.forEach((element) => {
                        filterScheduleArray.push(element);
                    });
                    if (allfilterScheduleArray.length == 0){
                        allfilterScheduleArray.push(filterScheduleArray)
                    }else {
                        allfilterScheduleArray.forEach((element) => {
                            if (element.includes(filterScheduleArray[0])){
                                scheduleExists = true;
                            }
                        })

                        if (scheduleExists == false){
                            allfilterScheduleArray.push(filterScheduleArray)
                        }
                    }
                }
            } 

            if(filterSchedule.length == 1){
                const hour = element["TimeDue"].split(":")[0];
                if (parseInt(hour) < 12 && parseInt(hour) > 3 ){
                    console.log("Morning");
                    document.querySelector(".js-header-morning").classList.remove("is-hidden");
                    showSchedule($containerMorning, element);
                
                } else if(parseInt(hour) >= 12 && parseInt(hour) < 18 ){
                    console.log("Afternoon");
                    document.querySelector(".js-header-afternoon").classList.remove("is-hidden");
                    showSchedule($containerAfternoon, element);
                
                }else if(parseInt(hour) >= 18 || parseInt(hour) <= 3){
                    console.log("Evening");
                    document.querySelector(".js-header-evening").classList.remove("is-hidden");
                    showSchedule($containerEvening, element);
                }
            }

            // const $scheduleDivs = document.querySelectorAll(".js-schedule-click");
            // $scheduleDivs.forEach((element) => {
            //     element.addEventListener("click", clickHandlerSchedule)
            // });
        });
       
        if (allfilterScheduleArray.length != 0){
            allfilterScheduleArray.forEach((element) => {
                const hour = element[0]["TimeDue"].split(":")[0];
                if (parseInt(hour) < 12 && parseInt(hour) > 3 ){
                    document.querySelector(".js-header-morning").classList.remove("is-hidden");
                    showGroupSchedule($containerMorning, element)
                
                } else if(parseInt(hour) >= 12 && parseInt(hour) < 18 ){
                    document.querySelector(".js-header-afternoon").classList.remove("is-hidden");
                    showGroupSchedule($containerAfternoon, element)

                }else if(parseInt(hour) >= 18 || parseInt(hour) <= 3){
                    document.querySelector(".js-header-evening").classList.remove("is-hidden");
                    showGroupSchedule($containerEvening, element)
                }
            }); 
        }
    });

    socket.on('medicationStatusTaken', showMedicationStatus)
    socket.on('medicationStatusNotTaken', showMedicationStatus)
    socket.on('medicationStatusNotTaken', showMedicationStatus)
}

const showSchedule = ($container, element) => {
    const $schedule = document.querySelector(".js-schedule");

    const schedule = $schedule.cloneNode(true);
    schedule.classList.remove("is-hidden")
    schedule.querySelector(".js-medication").classList.remove("is-hidden");

    schedule.querySelector(".js-name").innerHTML = element["Name"];
    if (element["Frequancy"] ==  1) {
        schedule.querySelector(".js-quantity").innerHTML = "1 pill"
    }else {
        schedule.querySelector(".js-quantity").innerHTML = element["Frequancy"] + " pills"
    }

    const timeArray =  element["TimeDue"].split(":");
    const time = ("0" + timeArray[0]).slice(-2) + ":" +  timeArray[1]
    schedule.querySelector(".js-time").innerHTML = time + "h"

    schedule.dataset.name = element["Name"];
    schedule.dataset.time = time;

    $container.appendChild(schedule);
}

const showGroupSchedule = ($container, elements) => {
    const $schedule = document.querySelector(".js-schedule");

    const schedule = $schedule.cloneNode(true);
    schedule.classList.remove("is-hidden")

    const timeArray =  elements[0]["TimeDue"].split(":");
    const time = ("0" + timeArray[0]).slice(-2) + ":" +  timeArray[1]
    schedule.querySelector(".js-time").innerHTML = time + "h"
    const $scheduleGroup = schedule.querySelector(".js-schedule-group");

    schedule.dataset.name = elements[0]["Name"];
    schedule.dataset.time = time;

    $container.appendChild(schedule);

    elements.forEach((element) => {
        const $medication = $scheduleGroup.querySelector(".js-medication")
        const medication = $medication.cloneNode(true);
        medication.classList.remove("is-hidden")
        medication.querySelector(".js-name").innerHTML = element["Name"];
        if (element["Frequancy"] ==  1) {
            medication.querySelector(".js-quantity").innerHTML = "1 pill"
        }else {
            medication.querySelector(".js-quantity").innerHTML = element["Frequancy"] + " pills"
        }

        $scheduleGroup.appendChild(medication);

    });
}

// const clickHandlerSchedule = e => {
//     const name = e.currentTarget.dataset.name;
//     const time =  e.currentTarget.dataset.time;
//     const date = new Date().toLocaleDateString();

//     var queryString = "?name=" + name + "&time=" + time + "&date=" + date;
//     window.location = "edit-dose-schedule.html" + queryString;
// }

const showMedicationStatus = medicationStatus => {
    medication  = JSON.parse(medicationStatus)
    let indexNotTaken = 0;

    medication.forEach((element) => {
        const timeArray =  element["TimeDue"].split(":");
        const time = ("0" + timeArray[0]).slice(-2) + ":" +  timeArray[1]

        const $medicationTaken = document.querySelectorAll(`[data-name= ${element["Name"]} ][data-time = "${time}"]`)[0];
        
        if ($medicationTaken) {
            const $statusDiv = $medicationTaken.querySelector('.js-status')
            if (element["IsTaken"] == "Taken"){
                $statusDiv.innerHTML= showSvg("Taken");
                $statusDiv.classList.add("is-taken");
            }else if (element["IsTaken"] == "Not taken"){
                $statusDiv.innerHTML= showSvg("Not taken");
                $statusDiv.classList.add("is-not-taken");
                indexNotTaken ++;
            }else if (element["IsTaken"] == "Late"){
                $statusDiv.innerHTML= showSvg("Late");
                $statusDiv.classList.add("is-taken-late");
            }
        }
    });

    if (indexNotTaken != 0) {
        const $container = document.querySelector(".js-ctnr-message");
        $container.classList.remove("is-hidden")
        if (indexNotTaken == 1) {
            $container.querySelector(".js-message").innerHTML = indexNotTaken + " dose"

        } else {
            $container.querySelector(".js-message").innerHTML = indexNotTaken + " doses"
        }
    } else {
        const $container = document.querySelector(".js-ctnr-message");
        $container.classList.add("is-hidden")
    }
}

const showSvg = status => {
    if(status == "Taken" || status == "Late"){
        return '<svg xmlns="http://www.w3.org/2000/svg" width="13.402" height="9.828" viewBox="0 0 13.402 9.828"><path d="M4.822,9.828a1.049,1.049,0,0,1-.752-.317L.311,5.68a1.1,1.1,0,0,1,0-1.532,1.049,1.049,0,0,1,1.5,0L4.822,7.212l6.766-6.9a1.049,1.049,0,0,1,1.5,0,1.1,1.1,0,0,1,0,1.532L5.573,9.511a1.05,1.05,0,0,1-.752.317" fill="#fff" /></svg>'

    }else if(status == "Not taken"){
        return '<svg xmlns="http://www.w3.org/2000/svg" width="13.402" height="9.828" viewBox="0 0 13.402 9.828"><path d="M4.822,9.828a1.049,1.049,0,0,1-.752-.317L.311,5.68a1.1,1.1,0,0,1,0-1.532,1.049,1.049,0,0,1,1.5,0L4.822,7.212l6.766-6.9a1.049,1.049,0,0,1,1.5,0,1.1,1.1,0,0,1,0,1.532L5.573,9.511a1.05,1.05,0,0,1-.752.317" fill="#fff" /></svg>'
    }
}

const clickHandlerNextDay= e => {
    e.preventDefault();
    const tomorrow = new Date();
    tomorrow.setDate(fullDate.getDate()+1);
    const date = tomorrow.getFullYear() +"-" +  ("0" + (tomorrow.getMonth() + 1)).slice(-2) + "-" +("0" + tomorrow.getDate()).slice(-2)
    if (window.innerWidth <= 1115){
        var queryString = "?date=" + date;
        window.location = "selected-day.html" + queryString;
    }
}


document.addEventListener('DOMContentLoaded', () => {
    console.info('DOM loaded');
    initSelectedDay();
});
