const tempArray = [];
const dataArray = [];

const weekday = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"];
const month = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sept", "Okt", "Nov", "Dec"];

const initTemperature = function () {
    socket.emit("getTemperature");

    socket.on("showSensorDataTemp", callbackShowSensorDataTemp);
};


const callbackShowSensorDataTemp = sensorData => {
    const temperatures = JSON.parse(sensorData);
    console.log(temperatures);
    temperatures.forEach(element => {
        tempArray.push(element["Value"])
        const newDate = new Date(element["MeasureDateTime"].split(' ')[0]);
        let date =  month[newDate.getMonth()] + " " + newDate.getDate() + "th " + element["MeasureDateTime"].split(' ')[1].split(':')[0] + "u" + element["MeasureDateTime"].split(' ')[1].split(':')[1]; 
        dataArray.push(date)
    });

    console.log(tempArray);
    console.log(dataArray);

    showchart(tempArray, dataArray)
}

const showchart = (data, labels) => {
    console.log(labels)
    console.log(data)
    const ctx = document.getElementById('myChart').getContext('2d');
    const myChart = new Chart(ctx, {
        type: 'line',
        data: {
            labels: labels,
            datasets: [{
                label: 'Temperature (°C)',
                data: data,
                backgroundColor: [
                    'rgba(83,185,234, 0.2)'
                ],
                borderColor: [
                    'rgba(83,185,234, 1)'
                ],
                borderWidth: 1,
            }]
        },
    
        options: {
            scales: {
                yAxes: [{
                    ticks: {
                        suggestedMin: 10, 
                        suggestedMax: 35,
                        stepSize: 5 
                    }
                }]
            }
        }
    });
} 



document.addEventListener('DOMContentLoaded', () => {
    console.info('DOM loaded');
    initTemperature();
});

